#!
# -*- coding: utf_8 -*-

"""

Text2Picture for OpenOffice.org

This software is a modified version of Text2Pic version 0.1.9 Copyright 2009 Rigpa IT modified by Robert Pinchbeck on 3/30/2013

Copyright 2013 Robert Pinchbeck

This file is part of Text2Picture.
  
Text2Picture is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Text2Picture is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Text2Picture.  If not, see <http://www.gnu.org/licenses/>.

"""

# modify these settings according to your extension

# implementation of the service
ImplementationName = "Text2Picture.Handler.OptionsDialog"

# URL of the Basic to handle the service process
BasicHandlerURL = "vnd.sun.star.script:Text2Picture.OptionsDialog.OptionsDialogHandler?language=Basic&location=application"


import unohelper

#interfaces
from com.sun.star.awt import XContainerWindowEventHandler
from com.sun.star.lang import XServiceInfo

# main class
class OptionsDialogHandler(unohelper.Base, XServiceInfo, XContainerWindowEventHandler):
    def __init__(self,ctx):
        self.ctx = ctx
        mspf = ctx.getValueByName(
            "/singletons/com.sun.star.script.provider.theMasterScriptProviderFactory")
        self.sp = mspf.createScriptProvider("")
        self.basicScript = self.sp.getScript(BasicHandlerURL)
        return
    
    # XContainerWindowEventHandler
    def callHandlerMethod(self,window,eventObject,method):
        if method == "external_event":
            try:
                self._handleExternalEvent(window, eventObject)
                return True
            except:
                return False
    
    # XContainerWindowEventHandler
    def getSupportedMethodNames(self):
        return ("external_event",)
    
    def _handleExternalEvent(self, window, eventName):
        if self.basicScript:
            self.basicScript.invoke((window, eventName), (), ())
        return
    
    
    # XServiceInfo
    def supportsService(self,name):
        return False
    
    def getImplementationName(self):
        return ImplementationName
    
    def getSupportedServiceNames(self):
        return ()

# uno implementation
g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(
    OptionsDialogHandler, 
    ImplementationName, 
    (ImplementationName,),)

